]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Report test failures from test_expect_*
[notmuch] / test / test-lib.sh
1 #!/usr/bin/env bash
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # if --tee was passed, write the output not only to the terminal, but
27 # additionally to the file test-results/$BASENAME.out, too.
28 case "$GIT_TEST_TEE_STARTED, $* " in
29 done,*)
30         # do not redirect again
31         ;;
32 *' --tee '*|*' --va'*)
33         mkdir -p test-results
34         BASE=test-results/$(basename "$0" .sh)
35         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
36          echo $? > $BASE.exit) | tee $BASE.out
37         test "$(cat $BASE.exit)" = 0
38         exit
39         ;;
40 esac
41
42 # Keep the original TERM for say_color
43 ORIGINAL_TERM=$TERM
44
45 # For repeatability, reset the environment to known value.
46 LANG=C
47 LC_ALL=C
48 PAGER=cat
49 TZ=UTC
50 TERM=dumb
51 export LANG LC_ALL PAGER TERM TZ
52 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$color"; then
120         say_color () {
121                 (
122                 TERM=$ORIGINAL_TERM
123                 export TERM
124                 case "$1" in
125                         error) tput bold; tput setaf 1;; # bold red
126                         skip)  tput bold; tput setaf 2;; # bold green
127                         pass)  tput setaf 2;;            # green
128                         info)  tput setaf 3;;            # brown
129                         *) test -n "$quiet" && return;;
130                 esac
131                 shift
132                 printf " "
133                 printf "$@"
134                 tput sgr0
135                 )
136         }
137 else
138         say_color() {
139                 test -z "$1" && test -n "$quiet" && return
140                 shift
141                 printf " "
142                 printf "$@"
143         }
144 fi
145
146 error () {
147         say_color error "error: $*\n"
148         GIT_EXIT_OK=t
149         exit 1
150 }
151
152 say () {
153         say_color info "$*"
154 }
155
156 test "${test_description}" != "" ||
157 error "Test script did not set test_description."
158
159 if test "$help" = "t"
160 then
161         echo "Tests ${test_description}"
162         exit 0
163 fi
164
165 echo $(basename "$0"): "Testing ${test_description}"
166
167 exec 5>&1
168
169 test_failure=0
170 test_count=0
171 test_fixed=0
172 test_broken=0
173 test_success=0
174
175 die () {
176         code=$?
177         if test -n "$GIT_EXIT_OK"
178         then
179                 exit $code
180         else
181                 echo >&5 "FATAL: Unexpected exit with code $code"
182                 exit 1
183         fi
184 }
185
186 GIT_EXIT_OK=
187 trap 'die' EXIT
188
189 test_decode_color () {
190         sed     -e 's/.\[1m/<WHITE>/g' \
191                 -e 's/.\[31m/<RED>/g' \
192                 -e 's/.\[32m/<GREEN>/g' \
193                 -e 's/.\[33m/<YELLOW>/g' \
194                 -e 's/.\[34m/<BLUE>/g' \
195                 -e 's/.\[35m/<MAGENTA>/g' \
196                 -e 's/.\[36m/<CYAN>/g' \
197                 -e 's/.\[m/<RESET>/g'
198 }
199
200 q_to_nul () {
201         perl -pe 'y/Q/\000/'
202 }
203
204 q_to_cr () {
205         tr Q '\015'
206 }
207
208 append_cr () {
209         sed -e 's/$/Q/' | tr Q '\015'
210 }
211
212 remove_cr () {
213         tr '\015' Q | sed -e 's/Q$//'
214 }
215
216 # Generate a new message in the mail directory, with a unique message
217 # ID and subject. The message is not added to the index.
218 #
219 # After this function returns, the filename of the generated message
220 # is available as $gen_msg_filename and the message ID is available as
221 # $gen_msg_id .
222 #
223 # This function supports named parameters with the bash syntax for
224 # assigning a value to an associative array ([name]=value). The
225 # supported parameters are:
226 #
227 #  [dir]=directory/of/choice
228 #
229 #       Generate the message in directory 'directory/of/choice' within
230 #       the mail store. The directory will be created if necessary.
231 #
232 #  [filename]=name
233 #
234 #       Store the message in file 'name'. The default is to store it
235 #       in 'msg-<count>', where <count> is three-digit number of the
236 #       message.
237 #       
238 #  [body]=text
239 #
240 #       Text to use as the body of the email message
241 #
242 #  '[from]="Some User <user@example.com>"'
243 #  '[to]="Some User <user@example.com>"'
244 #  '[subject]="Subject of email message"'
245 #  '[date]="RFC 822 Date"'
246 #
247 #       Values for email headers. If not provided, default values will
248 #       be generated instead.
249 #
250 #  '[cc]="Some User <user@example.com>"'
251 #  [reply-to]=some-address
252 #  [in-reply-to]=<message-id>
253 #  [references]=<message-id>
254 #  [content-type]=content-type-specification
255 #  '[header]=full header line, including keyword'
256 #
257 #       Additional values for email headers. If these are not provided
258 #       then the relevant headers will simply not appear in the
259 #       message.
260 #
261 #  '[id]=message-id'
262 #
263 #       Controls the message-id of the created message.
264 gen_msg_cnt=0
265 gen_msg_filename=""
266 gen_msg_id=""
267 generate_message ()
268 {
269     # This is our (bash-specific) magic for doing named parameters
270     local -A template="($@)"
271     local additional_headers
272
273     gen_msg_cnt=$((gen_msg_cnt + 1))
274     if [ -z "${template[filename]}" ]; then
275         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
276     else
277         gen_msg_name=${template[filename]}
278     fi
279
280     if [ -z "${template[id]}" ]; then
281         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
282     else
283         gen_msg_id="${template[id]}"
284     fi
285
286     if [ -z "${template[dir]}" ]; then
287         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
288     else
289         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
290         mkdir -p "$(dirname "$gen_msg_filename")"
291     fi
292
293     if [ -z "${template[body]}" ]; then
294         template[body]="This is just a test message (#${gen_msg_cnt})"
295     fi
296
297     if [ -z "${template[from]}" ]; then
298         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
299     fi
300
301     if [ -z "${template[to]}" ]; then
302         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
303     fi
304
305     if [ -z "${template[subject]}" ]; then
306         template[subject]="Test message #${gen_msg_cnt}"
307     fi
308
309     if [ -z "${template[date]}" ]; then
310         template[date]="Tue, 05 Jan 2001 15:43:57 -0000"
311     fi
312
313     additional_headers=""
314     if [ ! -z "${template[header]}" ]; then
315         additional_headers="${template[header]}
316 ${additional_headers}"
317     fi
318
319     if [ ! -z "${template[reply-to]}" ]; then
320         additional_headers="Reply-To: ${template[reply-to]}
321 ${additional_headers}"
322     fi
323
324     if [ ! -z "${template[in-reply-to]}" ]; then
325         additional_headers="In-Reply-To: ${template[in-reply-to]}
326 ${additional_headers}"
327     fi
328
329     if [ ! -z "${template[cc]}" ]; then
330         additional_headers="Cc: ${template[cc]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[references]}" ]; then
335         additional_headers="References: ${template[references]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[content-type]}" ]; then
340         additional_headers="Content-Type: ${template[content-type]}
341 ${additional_headers}"
342     fi
343
344     # Note that in the way we're setting it above and using it below,
345     # `additional_headers' will also serve as the header / body separator
346     # (empty line in between).
347
348     cat <<EOF >"$gen_msg_filename"
349 From: ${template[from]}
350 To: ${template[to]}
351 Message-Id: <${gen_msg_id}>
352 Subject: ${template[subject]}
353 Date: ${template[date]}
354 ${additional_headers}
355 ${template[body]}
356 EOF
357 }
358
359 # Generate a new message and add it to the database.
360 #
361 # All of the arguments and return values supported by generate_message
362 # are also supported here, so see that function for details.
363 add_message ()
364 {
365     generate_message "$@" &&
366     notmuch new > /dev/null
367 }
368
369 # Deliver a message with emacs and add it to the database
370 #
371 # Uses emacs to generate and deliver a message to the mail store.
372 # Accepts arbitrary extra emacs/elisp functions to modify the message
373 # before sending, which is useful to doing things like attaching files
374 # to the message and encrypting/signing.
375 emacs_deliver_message ()
376 {
377     local subject="$1"
378     local body="$2"
379     shift 2
380     # before we can send a message, we have to prepare the FCC maildir
381     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
382     $TEST_DIRECTORY/smtp-dummy sent_message &
383     smtp_dummy_pid=$!
384     test_emacs \
385         "(let ((message-send-mail-function 'message-smtpmail-send-it)
386                (smtpmail-smtp-server \"localhost\")
387                (smtpmail-smtp-service \"25025\"))
388            (notmuch-hello)
389            (notmuch-mua-mail)
390            (message-goto-to)
391            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
392            (message-goto-subject)
393            (insert \"${subject}\")
394            (message-goto-body)
395            (insert \"${body}\")
396            $@
397            (message-send-and-exit))" >/dev/null 2>&1
398     wait ${smtp_dummy_pid}
399     notmuch new >/dev/null
400 }
401
402 # Generate a corpus of email and add it to the database.
403 #
404 # This corpus is fixed, (it happens to be 50 messages from early in
405 # the history of the notmuch mailing list), which allows for reliably
406 # testing commands that need to operate on a not-totally-trivial
407 # number of messages.
408 add_email_corpus ()
409 {
410     rm -rf ${MAIL_DIR}
411     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
412         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
413     else
414         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
415         notmuch new >/dev/null
416         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
417     fi
418 }
419
420 test_begin_subtest ()
421 {
422     if [ -n "$inside_subtest" ]; then
423         exec 1>&6 2>&7          # Restore stdout and stderr
424         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
425     fi
426     test_subtest_name="$1"
427     test_subtest_known_broken_=
428     # Remember stdout and stderr file descriptors and redirect test
429     # output to the previously prepared file descriptors 3 and 4 (see
430     # below)
431     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
432     exec 6>&1 7>&2 >&3 2>&4
433     inside_subtest=t
434 }
435
436 # Pass test if two arguments match
437 #
438 # Note: Unlike all other test_expect_* functions, this function does
439 # not accept a test name. Instead, the caller should call
440 # test_begin_subtest before calling this function in order to set the
441 # name.
442 test_expect_equal ()
443 {
444         exec 1>&6 2>&7          # Restore stdout and stderr
445         inside_subtest=
446         test "$#" = 3 && { prereq=$1; shift; } || prereq=
447         test "$#" = 2 ||
448         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
449
450         output="$1"
451         expected="$2"
452         if ! test_skip "$test_subtest_name"
453         then
454                 if [ "$output" = "$expected" ]; then
455                         test_ok_ "$test_subtest_name"
456                 else
457                         testname=$this_test.$test_count
458                         echo "$expected" > $testname.expected
459                         echo "$output" > $testname.output
460                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
461                 fi
462     fi
463 }
464
465 test_expect_equal_file ()
466 {
467         exec 1>&6 2>&7          # Restore stdout and stderr
468         inside_subtest=
469         test "$#" = 3 && { prereq=$1; shift; } || prereq=
470         test "$#" = 2 ||
471         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
472
473         output="$1"
474         expected="$2"
475         if ! test_skip "$test_subtest_name"
476         then
477                 if diff -q "$expected" "$output" >/dev/null ; then
478                         test_ok_ "$test_subtest_name"
479                 else
480                         testname=$this_test.$test_count
481                         cp "$output" $testname.output
482                         cp "$expected" $testname.expected
483                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
484                 fi
485     fi
486 }
487
488 NOTMUCH_NEW ()
489 {
490     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
491 }
492
493 notmuch_search_sanitize ()
494 {
495     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
496 }
497
498 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
499 notmuch_show_sanitize ()
500 {
501     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
502 }
503 notmuch_show_sanitize_all ()
504 {
505     sed \
506         -e 's| filename:.*| filename:XXXXX|' \
507         -e 's| id:[^ ]* | id:XXXXX |'
508 }
509
510 notmuch_json_show_sanitize ()
511 {
512     sed -e 's|, |,\n |g' | \
513         sed \
514         -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
515         -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
516 }
517
518 # End of notmuch helper functions
519
520 # Use test_set_prereq to tell that a particular prerequisite is available.
521 # The prerequisite can later be checked for in two ways:
522 #
523 # - Explicitly using test_have_prereq.
524 #
525 # - Implicitly by specifying the prerequisite tag in the calls to
526 #   test_expect_{success,failure,code}.
527 #
528 # The single parameter is the prerequisite tag (a simple word, in all
529 # capital letters by convention).
530
531 test_set_prereq () {
532         satisfied="$satisfied$1 "
533 }
534 satisfied=" "
535
536 test_have_prereq () {
537         case $satisfied in
538         *" $1 "*)
539                 : yes, have it ;;
540         *)
541                 ! : nope ;;
542         esac
543 }
544
545 # You are not expected to call test_ok_ and test_failure_ directly, use
546 # the text_expect_* functions instead.
547
548 test_ok_ () {
549         if test "$test_subtest_known_broken_" = "t"; then
550                 test_known_broken_ok_ "$@"
551                 return
552         fi
553         test_success=$(($test_success + 1))
554         say_color pass "%-6s" "PASS"
555         echo " $@"
556 }
557
558 test_failure_ () {
559         if test "$test_subtest_known_broken_" = "t"; then
560                 test_known_broken_failure_ "$@"
561                 return
562         fi
563         test_failure=$(($test_failure + 1))
564         test_failure_message_ "FAIL" "$@"
565         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
566         return 1
567 }
568
569 test_failure_message_ () {
570         say_color error "%-6s" "$1"
571         echo " $2"
572         shift 2
573         echo "$@" | sed -e 's/^/        /'
574         if test "$verbose" != "t"; then cat test.output; fi
575 }
576
577 test_known_broken_ok_ () {
578         test_subtest_known_broken_=
579         test_fixed=$(($test_fixed+1))
580         say_color pass "%-6s" "FIXED"
581         echo " $@"
582 }
583
584 test_known_broken_failure_ () {
585         test_subtest_known_broken_=
586         test_broken=$(($test_broken+1))
587         test_failure_message_ "BROKEN" "$@"
588         return 1
589 }
590
591 test_debug () {
592         test "$debug" = "" || eval "$1"
593 }
594
595 test_run_ () {
596         test_cleanup=:
597         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
598         eval >&3 2>&4 "$1"
599         eval_ret=$?
600         eval >&3 2>&4 "$test_cleanup"
601         return 0
602 }
603
604 test_skip () {
605         test_count=$(($test_count+1))
606         to_skip=
607         for skp in $NOTMUCH_SKIP_TESTS
608         do
609                 case $this_test.$test_count in
610                 $skp)
611                         to_skip=t
612                 esac
613         done
614         if test -z "$to_skip" && test -n "$prereq" &&
615            ! test_have_prereq "$prereq"
616         then
617                 to_skip=t
618         fi
619         case "$to_skip" in
620         t)
621                 test_subtest_known_broken_=
622                 say_color skip >&3 "skipping test: $@"
623                 say_color skip "%-6s" "SKIP"
624                 echo " $1"
625                 : true
626                 ;;
627         *)
628                 false
629                 ;;
630         esac
631 }
632
633 test_subtest_known_broken () {
634         test_subtest_known_broken_=t
635 }
636
637 test_expect_success () {
638         test "$#" = 3 && { prereq=$1; shift; } || prereq=
639         test "$#" = 2 ||
640         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
641         if ! test_skip "$@"
642         then
643                 test_run_ "$2"
644                 if [ "$?" = 0 -a "$eval_ret" = 0 ]
645                 then
646                         test_ok_ "$1"
647                 else
648                         test_failure_ "$@"
649                 fi
650         fi
651 }
652
653 test_expect_code () {
654         test "$#" = 4 && { prereq=$1; shift; } || prereq=
655         test "$#" = 3 ||
656         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
657         if ! test_skip "$@"
658         then
659                 test_run_ "$3"
660                 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
661                 then
662                         test_ok_ "$2"
663                 else
664                         test_failure_ "$@"
665                 fi
666         fi
667 }
668
669 # test_external runs external test scripts that provide continuous
670 # test output about their progress, and succeeds/fails on
671 # zero/non-zero exit code.  It outputs the test output on stdout even
672 # in non-verbose mode, and announces the external script with "* run
673 # <n>: ..." before running it.  When providing relative paths, keep in
674 # mind that all scripts run in "trash directory".
675 # Usage: test_external description command arguments...
676 # Example: test_external 'Perl API' perl ../path/to/test.pl
677 test_external () {
678         test "$#" = 4 && { prereq=$1; shift; } || prereq=
679         test "$#" = 3 ||
680         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
681         descr="$1"
682         shift
683         if ! test_skip "$descr" "$@"
684         then
685                 # Announce the script to reduce confusion about the
686                 # test output that follows.
687                 say_color "" " run $test_count: $descr ($*)"
688                 # Run command; redirect its stderr to &4 as in
689                 # test_run_, but keep its stdout on our stdout even in
690                 # non-verbose mode.
691                 "$@" 2>&4
692                 if [ "$?" = 0 ]
693                 then
694                         test_ok_ "$descr"
695                 else
696                         test_failure_ "$descr" "$@"
697                 fi
698         fi
699 }
700
701 # Like test_external, but in addition tests that the command generated
702 # no output on stderr.
703 test_external_without_stderr () {
704         # The temporary file has no (and must have no) security
705         # implications.
706         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
707         stderr="$tmp/git-external-stderr.$$.tmp"
708         test_external "$@" 4> "$stderr"
709         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
710         descr="no stderr: $1"
711         shift
712         if [ ! -s "$stderr" ]; then
713                 rm "$stderr"
714                 test_ok_ "$descr"
715         else
716                 if [ "$verbose" = t ]; then
717                         output=`echo; echo Stderr is:; cat "$stderr"`
718                 else
719                         output=
720                 fi
721                 # rm first in case test_failure exits.
722                 rm "$stderr"
723                 test_failure_ "$descr" "$@" "$output"
724         fi
725 }
726
727 # This is not among top-level (test_expect_success | test_expect_failure)
728 # but is a prefix that can be used in the test script, like:
729 #
730 #       test_expect_success 'complain and die' '
731 #           do something &&
732 #           do something else &&
733 #           test_must_fail git checkout ../outerspace
734 #       '
735 #
736 # Writing this as "! git checkout ../outerspace" is wrong, because
737 # the failure could be due to a segv.  We want a controlled failure.
738
739 test_must_fail () {
740         "$@"
741         test $? -gt 0 -a $? -le 129 -o $? -gt 192
742 }
743
744 # test_cmp is a helper function to compare actual and expected output.
745 # You can use it like:
746 #
747 #       test_expect_success 'foo works' '
748 #               echo expected >expected &&
749 #               foo >actual &&
750 #               test_cmp expected actual
751 #       '
752 #
753 # This could be written as either "cmp" or "diff -u", but:
754 # - cmp's output is not nearly as easy to read as diff -u
755 # - not all diff versions understand "-u"
756
757 test_cmp() {
758         $GIT_TEST_CMP "$@"
759 }
760
761 # This function can be used to schedule some commands to be run
762 # unconditionally at the end of the test to restore sanity:
763 #
764 #       test_expect_success 'test core.capslock' '
765 #               git config core.capslock true &&
766 #               test_when_finished "git config --unset core.capslock" &&
767 #               hello world
768 #       '
769 #
770 # That would be roughly equivalent to
771 #
772 #       test_expect_success 'test core.capslock' '
773 #               git config core.capslock true &&
774 #               hello world
775 #               git config --unset core.capslock
776 #       '
777 #
778 # except that the greeting and config --unset must both succeed for
779 # the test to pass.
780
781 test_when_finished () {
782         test_cleanup="{ $*
783                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
784 }
785
786 test_done () {
787         GIT_EXIT_OK=t
788         test_results_dir="$TEST_DIRECTORY/test-results"
789         mkdir -p "$test_results_dir"
790         test_results_path="$test_results_dir/${0%.sh}-$$"
791
792         echo "total $test_count" >> $test_results_path
793         echo "success $test_success" >> $test_results_path
794         echo "fixed $test_fixed" >> $test_results_path
795         echo "broken $test_broken" >> $test_results_path
796         echo "failed $test_failure" >> $test_results_path
797         echo "" >> $test_results_path
798
799         echo
800
801         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
802
803         if [ "$test_failure" = "0" ]; then
804             if [ "$test_broken" = "0" ]; then       
805                 rm -rf "$remove_tmp"
806             fi
807             exit 0
808         else
809             exit 1
810         fi
811 }
812
813 emacs_generate_script () {
814         # Construct a little test script here for the benefit of the user,
815         # (who can easily run "run_emacs" to get the same emacs environment
816         # for investigating any failures).    
817         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
818 #!/bin/sh
819 export PATH=$PATH
820 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
821
822 # Here's what we are using here:
823 #
824 # --no-init-file        Don't load users ~/.emacs
825 #
826 # --no-site-file        Don't load the site-wide startup stuff
827 #
828 # --directory           Ensure that the local elisp sources are found
829 #
830 # --load                Force loading of notmuch.el and test-lib.el
831
832 emacs --no-init-file --no-site-file \
833         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
834         --directory "$TEST_DIRECTORY" --load test-lib.el \
835         "\$@"
836 EOF
837         chmod a+x "$TMP_DIRECTORY/run_emacs"
838 }
839
840 test_emacs () {
841         if [ -z "$EMACS_SERVER" ]; then
842                 EMACS_SERVER="notmuch-test-suite-$$"
843                 "$TMP_DIRECTORY/run_emacs" \
844                         --daemon \
845                         --eval "(setq server-name \"$EMACS_SERVER\")" \
846                         --eval "(orphan-watchdog $$)" || return
847         fi
848
849         emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
850 }
851
852
853 find_notmuch_path ()
854 {
855     dir="$1"
856
857     while [ -n "$dir" ]; do
858         bin="$dir/notmuch"
859         if [ -x "$bin" ]; then
860             echo "$dir"
861             return
862         fi
863         dir="$(dirname "$dir")"
864         if [ "$dir" = "/" ]; then
865             break
866         fi
867     done
868 }
869
870 # Test the binaries we have just built.  The tests are kept in
871 # test/ subdirectory and are run in 'trash directory' subdirectory.
872 TEST_DIRECTORY=$(pwd)
873 if test -n "$valgrind"
874 then
875         make_symlink () {
876                 test -h "$2" &&
877                 test "$1" = "$(readlink "$2")" || {
878                         # be super paranoid
879                         if mkdir "$2".lock
880                         then
881                                 rm -f "$2" &&
882                                 ln -s "$1" "$2" &&
883                                 rm -r "$2".lock
884                         else
885                                 while test -d "$2".lock
886                                 do
887                                         say "Waiting for lock on $2."
888                                         sleep 1
889                                 done
890                         fi
891                 }
892         }
893
894         make_valgrind_symlink () {
895                 # handle only executables
896                 test -x "$1" || return
897
898                 base=$(basename "$1")
899                 symlink_target=$TEST_DIRECTORY/../$base
900                 # do not override scripts
901                 if test -x "$symlink_target" &&
902                     test ! -d "$symlink_target" &&
903                     test "#!" != "$(head -c 2 < "$symlink_target")"
904                 then
905                         symlink_target=$TEST_DIRECTORY/valgrind.sh
906                 fi
907                 case "$base" in
908                 *.sh|*.perl)
909                         symlink_target=$TEST_DIRECTORY/unprocessed-script
910                 esac
911                 # create the link, or replace it if it is out of date
912                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
913         }
914
915         # override notmuch executable in TEST_DIRECTORY/..
916         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
917         mkdir -p "$GIT_VALGRIND"/bin
918         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
919         OLDIFS=$IFS
920         IFS=:
921         for path in $PATH
922         do
923                 ls "$path"/notmuch 2> /dev/null |
924                 while read file
925                 do
926                         make_valgrind_symlink "$file"
927                 done
928         done
929         IFS=$OLDIFS
930         PATH=$GIT_VALGRIND/bin:$PATH
931         GIT_EXEC_PATH=$GIT_VALGRIND/bin
932         export GIT_VALGRIND
933 else # normal case
934         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
935         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
936 fi
937 export PATH
938
939 # Test repository
940 test="tmp.$(basename "$0" .sh)"
941 test -n "$root" && test="$root/$test"
942 case "$test" in
943 /*) TMP_DIRECTORY="$test" ;;
944  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
945 esac
946 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
947 rm -fr "$test" || {
948         GIT_EXIT_OK=t
949         echo >&5 "FATAL: Cannot prepare test area"
950         exit 1
951 }
952
953 # A temporary home directory is needed by at least:
954 # - emacs/"Sending a message via (fake) SMTP"
955 # - emacs/"Reply within emacs"
956 # - crypto/emacs_deliver_message
957 export HOME="${TMP_DIRECTORY}/home"
958 mkdir -p "${HOME}"
959
960 MAIL_DIR="${TMP_DIRECTORY}/mail"
961 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
962 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
963
964 mkdir -p "${test}"
965 mkdir -p "${MAIL_DIR}"
966
967 cat <<EOF >"${NOTMUCH_CONFIG}"
968 [database]
969 path=${MAIL_DIR}
970
971 [user]
972 name=Notmuch Test Suite
973 primary_email=test_suite@notmuchmail.org
974 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
975 EOF
976
977 emacs_generate_script
978
979
980 # Use -P to resolve symlinks in our working directory so that the cwd
981 # in subprocesses like git equals our $PWD (for pathname comparisons).
982 cd -P "$test" || error "Cannot setup test environment"
983
984 if test "$verbose" = "t"
985 then
986         exec 4>&2 3>&1
987 else
988         exec 4>test.output 3>&4
989 fi
990
991 this_test=${0##*/}
992 for skp in $NOTMUCH_SKIP_TESTS
993 do
994         to_skip=
995         for skp in $NOTMUCH_SKIP_TESTS
996         do
997                 case "$this_test" in
998                 $skp)
999                         to_skip=t
1000                 esac
1001         done
1002         case "$to_skip" in
1003         t)
1004                 say_color skip >&3 "skipping test $this_test altogether"
1005                 say_color skip "skip all tests in $this_test"
1006                 test_done
1007         esac
1008 done
1009
1010 # Provide an implementation of the 'yes' utility
1011 yes () {
1012         if test $# = 0
1013         then
1014                 y=y
1015         else
1016                 y="$*"
1017         fi
1018
1019         while echo "$y"
1020         do
1021                 :
1022         done
1023 }
1024
1025 # Fix some commands on Windows
1026 case $(uname -s) in
1027 *MINGW*)
1028         # Windows has its own (incompatible) sort and find
1029         sort () {
1030                 /usr/bin/sort "$@"
1031         }
1032         find () {
1033                 /usr/bin/find "$@"
1034         }
1035         sum () {
1036                 md5sum "$@"
1037         }
1038         # git sees Windows-style pwd
1039         pwd () {
1040                 builtin pwd -W
1041         }
1042         # no POSIX permissions
1043         # backslashes in pathspec are converted to '/'
1044         # exec does not inherit the PID
1045         ;;
1046 *)
1047         test_set_prereq POSIXPERM
1048         test_set_prereq BSLASHPSPEC
1049         test_set_prereq EXECKEEPSPID
1050         ;;
1051 esac
1052
1053 test -z "$NO_PERL" && test_set_prereq PERL
1054 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1055
1056 # test whether the filesystem supports symbolic links
1057 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1058 rm -f y